var temp = localStorage.getItem("pipboy_temp");
var loc;

if(!temp){
	temp = 1;
}

function getWeatherloc(loc) {
			var req = new XMLHttpRequest();
			var url = "http://api.openweathermap.org/data/2.5/weather?lat=" + loc.coords.latitude.toFixed(2) + "&lon=" + loc.coords.longitude.toFixed(2);
			console.log("Requestiong weather at: " + url);
			req.open('GET', url, true);
			req.onload = function(e) {
				if (req.readyState == 4 && req.status == 200) {
					var response;
					try {
						response = JSON.parse(req.responseText);
					} catch (err) {
						console.log("Unable to parse JSON weather response");
						response = false;
					}
					//var temperature, icon, city, description;
					if (response && response.main && response.weather) {
						if(temp == 1){
							var weather_response = {
								"0": (response.main.temp - 273.15).toFixed(1)+" C",
								"1": getWeatherIcon(response.weather[0].id, response.sys.sunset, response.sys.sunrise),
								"2": response.name,
								"3": response.weather[0].main,
								"4": (response.main.temp_min - 273.15).toFixed(1),
								"5": (response.main.temp_max - 273.15).toFixed(1), 
								"6": response.main.pressure.toFixed(0),
								"7": response.main.humidity.toFixed(0),
								"8": loc.coords.latitude.toFixed(2),  
								"9": loc.coords.longitude.toFixed(2), 
							};
						}else{
							var f = (response.main.temp * 1.8) - 459.67;
							var f_min = (response.main.temp_min * 1.8) - 459.67;
							var f_max = (response.main.temp_max * 1.8) - 459.67;
							var weather_response = {
								"0": f.toFixed(1)+" F",
								"1": getWeatherIcon(response.weather[0].id, response.sys.sunset, response.sys.sunrise),
								"2": response.name,
								"3": response.weather[0].main,
								"4": f_min.toFixed(1),
								"5": f_max.toFixed(1), 
								"6": response.main.pressure.toFixed(0),
								"7": response.main.humidity.toFixed(0),
								"8": loc.coords.latitude.toFixed(2),  
								"9": loc.coords.longitude.toFixed(2), 
							};
						}
						console.log("DATA: "+weather_response[0]+" -- "+weather_response[1]+" -- "+weather_response[2]+" -- "+weather_response[3]);
						Pebble.sendAppMessage(weather_response);
						//callback(false, weather_response);
					} else {
						console.log("Weather response did not include expected elements: " + JSON.stringify(response));
						//callback(true);
					}
				} else {
					if (req.status !== 200) {
						console.log("XHR did not return 200: " + req.status);
					}
					//callback(true);
				}
			};
			req.send(null);

		}


function getWeatherIcon(weather_id, sunset, sunrise) {
			console.log("Weather ID: " + weather_id);
			var cdate = (new Date()).getTime()/1000;
			var is_day = (cdate < sunset && cdate > sunrise)? true : false;
			var icon = 0;
			if (weather_id < 200 || weather_id == 800) {
				icon = (is_day)? 0 : 1;
			} else if (weather_id <= 232) {
				//Thunderstorm
				icon = 2;//"P";
			} else if (weather_id <= 321) {
				//Drizzle
				icon = 3;//"Q";
			} else if (weather_id <= 600) {
				//Rain
				icon = 4;//"R";
			} else if (weather_id <= 700) {
				//Snow
				icon = 5;//"W";
			} else if (weather_id <= 800) {
				//Mist
				icon = (is_day)? 6 : 7;
			} else if (weather_id <= 900) {
				//Clouds
				icon = 8;
			} else if (weather_id < 950) {
				//900	 tornado
				//901	 tropical storm
				//902	 hurricane
				//903	 cold
				//904	 hot
				//905	 windy
				//906	 hail
				icon = 9;
			}
			return icon;	
		}

function getLocation(){
		window.navigator.geolocation.getCurrentPosition( function(loc) {
					console.log(loc);
					getWeatherloc(loc);	
					return loc;
				} ,function(err) {
					console.log(err);
				}, 
				{
					timeout: 15000,
					maximumAge: 10000
				});
}				

// Set callback for the app ready event
Pebble.addEventListener("ready",
                        function(e) {
                          console.log("connect!" + e.ready);
                          console.log(e.type);
						  temp = localStorage.getItem("pipboy_temp");
						  loc = getLocation();	
                        });

Pebble.addEventListener("showConfiguration",
		function(e) {
			Pebble.openURL("http://bertderuiter.nl/downloads/pipboy.php?temp="+temp);
	}
);


Pebble.addEventListener("webviewclosed",
  function(e) {
      console.log("Configuration window returned: " + e.response);
	  if(e.response == "CANCELLED"){
		  return;
	  }
	  //1 = celcius, 0 = fahrenheit
	  var str = e.response;
	  var n = str.indexOf("&")+1;
	  localStorage.setItem("pipboy_temp", str.substring(n,80));
	  temp = localStorage.getItem("pipboy_temp");
	  console.log(temp);
	  loc = getLocation();
  }
);

// Set callback for appmessage events
Pebble.addEventListener("appmessage",
                        function(e) {
                          console.log("message");
							console.log("Received message: " + e.payload[1]);
							localStorage.setItem("pipboy_24h", e.payload[1]);
							type = e.payload[1];
							//Pebble.sendAppMessage({"2": "refresh"});
                            loc = getLocation();
                         
                        });
